/* DO NOT TOUCH, CHANGE THE UPDATE RATE via SETTINGS
 * The update rate defines how often new data will be called
 * A lower value means a faster update rate, calculate your update rate with the network optimizer in settings, e.g.
 * 25 ms ~40 updates per second,
 * 50 ms ~20 updates per second,
 * 100 ms ~10 updates per second,
 * 125 ms ~8 updates per second,
 * 200 ms ~5 updates per second
*/
var updateRate = 50;

// Availaible JSON Data in Data Fields (only JSON Data Type 2 and 3)
// static info
var Sim, Session, Speedunit, TempUnit, PresUnit, Cars, Car, Group, Sectors, MAXRPM, ShiftIndicator, FuelMAX, SuspensionMAX;
// general data
var BestRPM, Topspeed, Current, Last, Best, CurrentSector, SectorTimes, BestSectorTimes, Laps, Pos, TyreTemp, TyrePress, TyreWear, TyreDirt, Tyre, Fuel, Distance, LapDistance, InPit, NumberOfLaps, Damage, CamberRAD, Suspension, WheelLoad, AvgFuel, FuelLapsLeft, ET, OT, TimeLeft, Status;

var c = 1000/updateRate;
var modUpdate = c;
var init = true;

// timeouts
var timeout_jt1 = updateRate*2;
var timeout_jt2 = updateRate*5;
var timeout_jt3 = updateRate*10;

function ajaxRequest() {	
    var activexmodes = ["Msxml2.XMLHTTP", "Microsoft.XMLHTTP"] //activeX versions to check for in IE
	if (window.XMLHttpRequest) // if Mozilla, Safari etc
        return new XMLHttpRequest();
    else if (window.ActiveXObject) { //Test for support for ActiveXObject in IE first (as XMLHttpRequest in IE7 is broken) <-- not working on windows phone
        for (var i = 0; i < activexmodes.length; i++) {
            try {
                return new ActiveXObject(activexmodes[i]);
            }
            catch (e) {
                //suppress error
            }
        }
    }    
    else{
        return false;}
}

function sendRequest() {
    var getRequest = new ajaxRequest();
    getRequest.onreadystatechange = function () {
		//alert(getRequest.readyState+" - "+getRequest.status);
        if (getRequest.readyState == 4) {
            if (getRequest.status == 200 || window.location.href.indexOf("http") == -1) {
                var json = eval("(" + getRequest.responseText + ")") //retrieve result as an JavaScript object
				switch(json.jtype)
				{
					case 1:
						updateType1(json);
						break;
					case 2: 
						updateType2Data(json);
						break;
					case 3:
						updateType3Data(json);
						break;
					default: break;
				}
            }
            else {
                // alert("An error has occured making the request");
            }
        }
    }
	if(c % modUpdate == 0)
	{
		if(init){
			init = false;
			getRequest.open("GET", "json3", true);
			getRequest.timeout = timeout_jt3;			
		}
		else{
			getRequest.open("GET", "json2", true);
			getRequest.timeout = timeout_jt2;
		}
		c = 1;
	}
	else
	{
		getRequest.open("GET", "json1", true);
		getRequest.timeout = timeout_jt1;
		c++;
	}
	getRequest.ontimeout = function() {
		getRequest.abort();
		window.setTimeout(sendRequest, 0);		
	}
	//getRequest.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
	//getRequest.setRequestHeader("Connection", "close");
    getRequest.send(null);
}

sendRequest();

function updateType3Data(json)
{
	Sim = json.Sim;	
	Session = json.Session;
	Speedunit = json.Speedunit;
	TempUnit = json.TempUnit;
	PresUnit = json.PresUnit;
	Cars = json.Cars;
	Car = json.Car;
	Group = json.Group;
	Sectors = json.Sectors;
	MAXRPM = json.MAXRPM;
	ShiftIndicator = json.ShiftIndicator;
	FuelMAX = json.FuelMAX;
	SuspensionMAX = json.SuspensionMAX;
	
	updateType3(json);
	updateType2Data(json);
}

function updateType2Data(json)
{		
	BestRPM = json.BestRPM;
	Topspeed = json.Topspeed;
	Current = json.Current;
	Last = json.Last;
	Best = json.Best;
	CurrentSector = json.CurrentSector;
	SectorTimes = json.SectorTimes;
	BestSectorTimes = json.BestSectorTimes;
	Laps = json.Laps;
	Pos = json.Pos;
	Damage = json.Damage;
	CamberRAD = json.CamberRAD;
	Suspension = json.Suspension;
	WheelLoad = json.WheelLoad;
	TyreTemp = json.TyreTemp;
	TyrePress = json.TyrePress;
	TyreWear = json.TyreWear;
	TyreDirt = json.TyreDirt;
	Tyre = json.Tyre;
	Fuel = json.Fuel;
	AvgFuel = json.AvgFuel;
	FuelLapsLeft = json.FuelLapsLeft;
	Distance = json.Distance;
	LapDistance = json.LapDistance;
	InPit = json.InPit;
	NumberOfLaps = json.NumberOfLaps;
	ET = json.ET;
	OT = json.OT;
	TimeLeft = json.TimeLeft;
	Status = json.Status;
	
	updateType2(json);
	updateType1(json);
}
